package com.mao.common.util;

import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;

import org.apache.tomcat.util.codec.binary.Base64;

/**
 * 
 * 描述：密钥生成器
 * @author mao2080@sina.com
 * @created 2017年4月20日 下午8:32:20
 * @since
 */
public class Generator {

    public static final String ALGORITHM_RSA = "RSA";

    public static void main(String[] args) throws Exception {
        KeyPairGenerator keyPairGen = KeyPairGenerator.getInstance(ALGORITHM_RSA);
        keyPairGen.initialize(1024);
        KeyPair keyPair = keyPairGen.generateKeyPair();
        RSAPublicKey rsaPublicKey = (RSAPublicKey) keyPair.getPublic();
        byte[] keyBs = rsaPublicKey.getEncoded();
        String publicKey = encodeBase64(keyBs);
        System.out.println("生成的公钥：\r\n" + publicKey);
        RSAPrivateKey rsaPrivateKey = (RSAPrivateKey) keyPair.getPrivate();
        keyBs = rsaPrivateKey.getEncoded();
        String  privateKey = encodeBase64(keyBs);
        System.out.println("生成的私钥：\r\n" + privateKey);
    }
    
    /**
     * 
     * 描述：byte数组转String
     * @author mao2080@sina.com
     * @created 2017年4月9日 下午8:43:05
     * @since 
     * @param source
     * @return
     * @throws Exception
     */
    public static String encodeBase64(byte[] source) throws Exception {
        return new String(Base64.encodeBase64(source), "UTF-8");
    }

    /**
     * 
     * 描述：String转byte数组
     * @author mao2080@sina.com
     * @created 2017年4月9日 下午8:42:59
     * @since 
     * @param target
     * @return
     * @throws Exception
     */
    public static byte[] decodeBase64(String target) throws Exception {
        return Base64.decodeBase64(target.getBytes("UTF-8"));
    }

}